<a id="mypy-boto3-emr-containers"></a>

# mypy-boto3-emr-containers

[![PyPI - mypy-boto3-emr-containers](https://img.shields.io/pypi/v/mypy-boto3-emr-containers.svg?color=blue)](https://pypi.org/project/mypy-boto3-emr-containers)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-emr-containers.svg?color=blue)](https://pypi.org/project/mypy-boto3-emr-containers)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-emr-containers?color=blue)](https://pypistats.org/packages/mypy-boto3-emr-containers)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.EMRContainers 1.18.51](https://boto3.amazonaws.com/v1/documentation/api/1.18.51/reference/services/emr-containers.html#EMRContainers)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 5.5.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-emr-containers docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_emr_containers/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-emr-containers](#mypy-boto3-emr-containers)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `EMRContainers` service.

```bash
python -m pip install boto3-stubs[emr-containers]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[emr-containers]` in your environment:
  `python -m pip install 'boto3-stubs[emr-containers]'`

Both type checking and auto-complete should work for `EMRContainers` service.
No explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[emr-containers]` in your environment:
  `python -m pip install 'boto3-stubs[emr-containers]'`

Both type checking and auto-complete should work for `EMRContainers` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[emr-containers]` in your environment:
  `python -m pip install 'boto3-stubs[emr-containers]'`
- Run `mypy` as usual

Type checking should work for `EMRContainers` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[emr-containers]` in your environment:
  `python -m pip install 'boto3-stubs[emr-containers]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `EMRContainers` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`EMRContainersClient` provides annotations for
`boto3.client("emr-containers")`.

```python
import boto3

from mypy_boto3_emr_containers import EMRContainersClient

client: EMRContainersClient = boto3.client("emr-containers")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: EMRContainersClient = session.client("emr-containers")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_emr_containers.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_emr_containers import EMRContainersClient
from mypy_boto3_emr_containers.paginator import (
    ListJobRunsPaginator,
    ListManagedEndpointsPaginator,
    ListVirtualClustersPaginator,
)

client: EMRContainersClient = boto3.client("emr-containers")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_job_runs_paginator: ListJobRunsPaginator = client.get_paginator("list_job_runs")
list_managed_endpoints_paginator: ListManagedEndpointsPaginator = client.get_paginator("list_managed_endpoints")
list_virtual_clusters_paginator: ListVirtualClustersPaginator = client.get_paginator("list_virtual_clusters")
```

<a id="literals"></a>

### Literals

`mypy_boto3_emr_containers.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_emr_containers.literals import (
    ContainerProviderTypeType,
    EndpointStateType,
    FailureReasonType,
    JobRunStateType,
    ListJobRunsPaginatorName,
    ListManagedEndpointsPaginatorName,
    ListVirtualClustersPaginatorName,
    PersistentAppUIType,
    VirtualClusterStateType,
    ServiceName,
    PaginatorName,
)

def check_value(value: ContainerProviderTypeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_emr_containers.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_emr_containers.type_defs import (
    CancelJobRunRequestRequestTypeDef,
    CancelJobRunResponseTypeDef,
    CloudWatchMonitoringConfigurationTypeDef,
    ConfigurationOverridesTypeDef,
    ConfigurationTypeDef,
    ContainerInfoTypeDef,
    ContainerProviderTypeDef,
    CreateManagedEndpointRequestRequestTypeDef,
    CreateManagedEndpointResponseTypeDef,
    CreateVirtualClusterRequestRequestTypeDef,
    CreateVirtualClusterResponseTypeDef,
    DeleteManagedEndpointRequestRequestTypeDef,
    DeleteManagedEndpointResponseTypeDef,
    DeleteVirtualClusterRequestRequestTypeDef,
    DeleteVirtualClusterResponseTypeDef,
    DescribeJobRunRequestRequestTypeDef,
    DescribeJobRunResponseTypeDef,
    DescribeManagedEndpointRequestRequestTypeDef,
    DescribeManagedEndpointResponseTypeDef,
    DescribeVirtualClusterRequestRequestTypeDef,
    DescribeVirtualClusterResponseTypeDef,
    EksInfoTypeDef,
    EndpointTypeDef,
    JobDriverTypeDef,
    JobRunTypeDef,
    ListJobRunsRequestRequestTypeDef,
    ListJobRunsResponseTypeDef,
    ListManagedEndpointsRequestRequestTypeDef,
    ListManagedEndpointsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    ListVirtualClustersRequestRequestTypeDef,
    ListVirtualClustersResponseTypeDef,
    MonitoringConfigurationTypeDef,
    PaginatorConfigTypeDef,
    ResponseMetadataTypeDef,
    S3MonitoringConfigurationTypeDef,
    SparkSubmitJobDriverTypeDef,
    StartJobRunRequestRequestTypeDef,
    StartJobRunResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    VirtualClusterTypeDef,
)

def get_structure() -> CancelJobRunRequestRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-emr-containers` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-emr-containers docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_emr_containers/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
